//+------------------------------------------------------------------+
//|                                                 s-Downloader.mq4 |
//|                                          Copyright  2009, Talex |
//|                                      talex.kaliningrad@gmail.com |
//+------------------------------------------------------------------+
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
        ,  
   " "  .   
    HOME,     , ..
          5 ,  
  ,          
    .    , -
  ,  , "" .
           
      ,  
      .
    Ilnur, getch, Zhunko, YuraZ   
   http://forum.mql4.com/ru/     WINAPI,  
         .
*///++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#property copyright "Copyright  2009, Talex"
#property link      "talex.kaliningrad@gmail.com"

#include <SymbolsLib.mqh>

#import "user32.dll"
   int GetAncestor (int hWnd, int gaFlags);
   int GetParent (int hWnd);
   int GetDlgItem (int hDlg, int nIDDlgItem);
   int SendMessageA (int hWnd, int Msg, int wParam, int lParam);
   int PostMessageA (int hWnd, int Msg, int wParam, int lParam);
#import
#define LVM_GETITEMCOUNT   0x1004
#define WM_COMMAND         0x0111
#define WM_SCROLL          0x80F9
#define WM_KEYDOWN         0x0100
#define WM_CLOSE           0x0010
#define VK_HOME            0x24
#define VK_END             0x23
#define VK_DOWN            0x28

bool MarketWatch = true;        // true -   " ", false -   
int nsymb,Pause=500;
string Symbols[];                                //      
//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
void start() {
   int i;
//--------------------------------------------------------------------
   if(GlobalVariableCheck("glSymbolHandle")) {   //     .
      GlobalVariableSet("glSymbolHandle",WindowHandle(Symbol(),Period())); //    . 
      nsymb=SymbolsList(Symbols,MarketWatch);
      for(i=0;i<nsymb;i++) {                     //      
         if(Symbols[i]==Symbol()) {              //   Symbols[i]  
            GlobalVariableSet("glSymbol",i);     //  .
            return;                                                        
         }
      }
      return;
   } 
   SymbolsList(Symbols,MarketWatch);             //        Symbols[]
   DownloadHomeKey();                            //     " "
   return;                                       //    HOME,   
}
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//| DownloadHomeKey()                                                |
//| :                                                      |
//|               |
//|       HOME                                         |
//+------------------------------------------------------------------+
void DownloadHomeKey() {
   int i,j,k,hmain,handle,handlechart,count,num,
       TF[8]={33136,33134,33141,33334,33137,33138,33139,33140},
       tf[9]={60,240,1440,10080,43200,1,5,15,30};
   datetime ebt,prebt;
//------------------------------------
   GlobalVariableSet("glSymbolHandle",WindowHandle(Symbol(),Period()));
   hmain=GetAncestor(WindowHandle(Symbol(),Period()),2);   //    .
   if (hmain!=0) { 
      handle=GetDlgItem(hmain,0xE81C);                    
      handle=GetDlgItem(handle,0x50);
      handle=GetDlgItem(handle,0x8A71);                    //   .
      count=SendMessageA(handle,LVM_GETITEMCOUNT,0,0);     //    .
   }
   else Print(" : ",GetLastError());
   for(i=1;i<=count&&!IsStopped();i++) {                   //      .
      OpenChart(i,hmain);                                  //       " "
      Sleep(Pause);
      PostMessageA(hmain,WM_COMMAND,33042,0);              //   ,     .
      Sleep (Pause);
      handlechart=GlobalVariableGet ("glSymbolHandle");    //   ,   .
      for (j=0;j<9&&!IsStopped();j++) {                    //    
         if (j!=0) {                                       //   .     H1.
            PostMessageA(handlechart,WM_COMMAND,TF[j-1],0);//  .
         }
         k=0;
         PostMessageA(handlechart,WM_COMMAND,WM_SCROLL,0); //  
         while(!IsStopped()) {
            PostMessageA(handlechart,WM_KEYDOWN,VK_HOME,0);//   "HOME"
            Sleep(1000);
            num=GlobalVariableGet("glSymbol");             //    
            ebt=iTime(Symbols[num],tf[j],(iBars(Symbols[num],tf[j])-1));//    
            if(ebt!=prebt) {                               //   ,   
               prebt=ebt;
               k=0;
            }
            else k++;                                      //      1
            if(k>4) break;                                 //     4,  ""  HOME
         }
         PostMessageA(handlechart,WM_KEYDOWN,VK_END,0);    //     ( ?) :)
         PostMessageA(handlechart,WM_COMMAND,WM_SCROLL,0); //  
         PostMessageA(handlechart,WM_COMMAND,33324,0);     //     " "
         Sleep(Pause);
      }
      PostMessageA(GetParent(handlechart),WM_CLOSE,0,0);   //   . 
      Sleep(Pause);
   }
   GlobalVariableDel ("glSymbolHandle");                   //   
   GlobalVariableDel ("glSymbol");
   return;
}
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//| OpenChart()                                                      |
//| :                                                      |
//|       " ".            |
//+------------------------------------------------------------------+
void OpenChart (int Num, int handle) {
   int hwnd;
//-------------------------------------  
   hwnd=GetDlgItem(handle,0xE81C); 
   hwnd=GetDlgItem(hwnd,0x50);
   hwnd=GetDlgItem(hwnd,0x8A71);                 //  " ".
   PostMessageA(hwnd,WM_KEYDOWN,VK_HOME,0);      //    " ".
   while (Num>1) {
      PostMessageA(hwnd,WM_KEYDOWN,VK_DOWN,0);   //    .
      Num--;
   }
   PostMessageA(handle,WM_COMMAND,33160,0);      //  .
   return;
}
//+------------------------------------------------------------------+